package javax.xml.bind;

import javax.xml.validation.Schema;
import javax.xml.bind.attachment.AttachmentMarshaller;
import javax.xml.bind.annotation.adapters.XmlAdapter;
import javax.xml.stream.XMLEventWriter;
import javax.xml.stream.XMLStreamWriter;
import org.w3c.dom.Node;
import org.xml.sax.ContentHandler;
import java.io.Writer;
import java.io.File;
import java.io.OutputStream;
import javax.xml.transform.Result;

public interface Marshaller
{
    public static final String JAXB_ENCODING = "jaxb.encoding";
    public static final String JAXB_FORMATTED_OUTPUT = "jaxb.formatted.output";
    public static final String JAXB_SCHEMA_LOCATION = "jaxb.schemaLocation";
    public static final String JAXB_NO_NAMESPACE_SCHEMA_LOCATION = "jaxb.noNamespaceSchemaLocation";
    public static final String JAXB_FRAGMENT = "jaxb.fragment";
    
    public abstract void marshal(Object p0, Result p1) throws JAXBException;
    
    public abstract void marshal(Object p0, OutputStream p1) throws JAXBException;
    
    public abstract void marshal(Object p0, File p1) throws JAXBException;
    
    public abstract void marshal(Object p0, Writer p1) throws JAXBException;
    
    public abstract void marshal(Object p0, ContentHandler p1) throws JAXBException;
    
    public abstract void marshal(Object p0, Node p1) throws JAXBException;
    
    public abstract void marshal(Object p0, XMLStreamWriter p1) throws JAXBException;
    
    public abstract void marshal(Object p0, XMLEventWriter p1) throws JAXBException;
    
    public abstract Node getNode(Object p0) throws JAXBException;
    
    public abstract void setProperty(String p0, Object p1) throws PropertyException;
    
    public abstract Object getProperty(String p0) throws PropertyException;
    
    public abstract void setEventHandler(ValidationEventHandler p0) throws JAXBException;
    
    public abstract ValidationEventHandler getEventHandler() throws JAXBException;
    
    public abstract void setAdapter(XmlAdapter p0);
    
    public abstract <A extends XmlAdapter> void setAdapter(Class<A> p0, A p1);
    
    public abstract <A extends XmlAdapter> A getAdapter(Class<A> p0);
    
    public abstract void setAttachmentMarshaller(AttachmentMarshaller p0);
    
    public abstract AttachmentMarshaller getAttachmentMarshaller();
    
    public abstract void setSchema(Schema p0);
    
    public abstract Schema getSchema();
    
    public abstract void setListener(Marshaller.Listener p0);
    
    public abstract Marshaller.Listener getListener();
    
    public abstract static class Listener
    {
        public void beforeMarshal(Object source) {
        }
        
        public void afterMarshal(Object source) {
        }
    }
}
